local coveredBridge = ...
coveredBridge:registerAssetProcessor("models/coveredBridgeAddition.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})


--------------------------------------------------------------------------

-- Register IDs for all prefab nodes referenced here
coveredBridge:registerAssetId("models/coveredBridgeAddition.fbx/Prefab/coveredBridge/HatPart", "COVERED_BRIDGE_HAT_PREFAB")
coveredBridge:registerAssetId("models/coveredBridgeAddition.fbx/Prefab/coveredBridge/KnifePart", "COVERED_BRIDGE_KNIFE_PREFAB")

-- Register the workplace decoration part
coveredBridge:register({
	DataType = "BUILDING_PART",
	Id = "COVERED_BRIDGE_HAT_PART",
	Name = "COVERED_BRIDGE_HAT_NAME",
	Description = "COVERED_BRIDGE_HAT_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "COVERED_BRIDGE_HAT_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 5 }
		}
	},
	AssetBuildingFunction = "COVERED_BRIDGE_HAT_FUNCTION"
})
coveredBridge:register({
		DataType = "BUILDING_FUNCTION_MARKET",
                Id = "COVERED_BRIDGE_HAT_FUNCTION",
                TypeList = { "GOODS" },
                IsOverrideCapacity = true,
                CapacityPerSlot = 20,
		WorkerCapacity = 1,
                RelatedJob = { Job = "HATMAKER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
                },
                ResourceListNeeded = {
                	{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "HAT", Quantity = 1 }
                }
})

-- Register the workplace decoration part
coveredBridge:register({
	DataType = "BUILDING_PART",
	Id = "COVERED_BRIDGE_KNIFE_PART",
	Name = "COVERED_BRIDGE_KNIFE_NAME",
	Description = "COVERED_BRIDGE_KNIFE_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "COVERED_BRIDGE_KNIFE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 5 }
		}
	},
	AssetBuildingFunction = "COVERED_BRIDGE_KNIFE_FUNCTION"
})
coveredBridge:register({
		DataType = "BUILDING_FUNCTION_MARKET",
                Id = "COVERED_BRIDGE_KNIFE_FUNCTION",
                TypeList = { "GOODS" },
                IsOverrideCapacity = true,
                CapacityPerSlot = 20,
		WorkerCapacity = 1,
                RelatedJob = { Job = "KNIFEGRINDER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "TOOL", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "TOOL", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "KNIFE", Quantity = 1 }
                }
})

--------------------------------------------------------------------------

-- Override building part components properties (generated by the building asset processor) to add building zones

coveredBridge:registerPrefabComponent("models/coveredBridgeAddition.fbx/Prefab/coveredBridge/HatPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes
	BuildingZone = { 4, 4 }
})

coveredBridge:registerPrefabComponent("models/coveredBridgeAddition.fbx/Prefab/coveredBridge/KnifePart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes
	BuildingZone = { 4, 4 }
})
